# TODO:
# - package vendored modules
# - package fzf-tmux

%define		fzfrev		19759ed
%define		fzfvimrev	a88311b
%define		vendor_version	0.27.0

Summary:	A command-line fuzzy finder written in Go
Name:		fzf
Version:	0.27.1
Release:	1
License:	MIT
Group:		Applications/Shells
#Source0Download: https://github.com/junegunn/fzf/releases
Source0:	https://github.com/junegunn/fzf/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	31420cb678ce9f056d39d8bec46f690a
# cd fzf-%{version}
# go mod vendor
# cd ..
# tar cJf fzf-vendor-%{version}.tar.xz fzf-%{version}/vendor
Source1:	%{name}-vendor-%{vendor_version}.tar.xz
# Source1-md5:	8f6ede1f36704a492d45b534c18a0124
Source2:	https://github.com/junegunn/fzf.vim/archive/%{fzfvimrev}/fzf.vim-%{fzfvimrev}.tar.gz
# Source2-md5:	6095e1cb0e42900e1acbbc0c91b65a70
URL:		https://github.com/junegunn/fzf
BuildRequires:	golang >= 1.13
BuildRequires:	rpmbuild(macros) >= 2.005
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
ExclusiveArch:	%{ix86} %{x8664} %{arm} aarch64 mips64 mips64le ppc64 ppc64le s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_debugsource_packages	0

%description
fzf is a general-purpose command-line fuzzy finder.

It's an interactive Unix filter for command-line that can be used with
any list; files, command history, processes, hostnames, bookmarks, git
commits, etc.

%package -n bash-completion-fzf
Summary:	bash-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion >= 2.0
BuildArch:	noarch

%description -n bash-completion-fzf
bash-completion for fzf.

%package -n zsh-completion-fzf
Summary:	zsh-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	zsh
BuildArch:	noarch

%description -n zsh-completion-fzf
zsh-completion for fzf.

%package -n vim-plugin-fzf
Summary:	fzf integration for Vim
Group:		Applications/Editors/Vim
Requires:	%{name} >= 0.23.0
Requires:	file
Requires:	vim-rt
Suggests:	highlight
Suggests:	the_silver_searcher
BuildArch:	noarch

%description -n vim-plugin-fzf
fzf integration for Vim.

%package -n vim-plugin-fzf-doc
Summary:	Documentation for fzf Vim plugin
Group:		Applications/Editors/Vim
Requires:	vim-plugin-fzf = %{version}-%{release}
Requires:	vim-rt
BuildArch:	noarch

%description -n vim-plugin-fzf-doc
Documentation for fzf Vim plugin.

%prep
%setup -q -a1 -a2
%{__mv} fzf-%{vendor_version}/vendor .
%{__mv} fzf.vim-%{fzfvimrev}* fzf.vim
%{__sed} -i -e "s@let s:bin_dir = .*@let s:bin_dir = '%{_datadir}/fzf/vim/bin/'@" fzf.vim/autoload/fzf/vim.vim
%{__sed} -i -e '1s,.*env bash,#!/bin/bash,' fzf.vim/bin/preview.sh
%{__sed} -i -e '1s,.*env perl,#!%{__perl},' fzf.vim/bin/tags.pl

%{__mkdir_p} .go-cache

%build
GOCACHE="$(pwd)/.go-cache" go build -v -mod=vendor -ldflags='-X main.version=%{version} -X main.revision=%{fzfrev}' -o target/fzf

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/fzf/vim/bin,%{_mandir}/man1,%{bash_compdir},%{zsh_compdir}}
install -d $RPM_BUILD_ROOT%{_datadir}/vim/{doc,autoload,plugin/fzf}

cp -p target/fzf $RPM_BUILD_ROOT%{_bindir}/fzf
cp -p man/man1/fzf.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p shell/completion.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/completion.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -rp fzf.vim/autoload/fzf $RPM_BUILD_ROOT%{_datadir}/vim/autoload
cp -p plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf.vim
cp -p fzf.vim/plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf/fzf.vim
cp -p fzf.vim/doc/fzf-vim.txt $RPM_BUILD_ROOT%{_datadir}/vim/doc/fzf.txt
cp -p fzf.vim/bin/{preview.sh,tags.pl} $RPM_BUILD_ROOT%{_datadir}/fzf/vim/bin

%clean
rm -rf $RPM_BUILD_ROOT

%post -n vim-plugin-fzf-doc
%vim_doc_helptags

%postun -n vim-plugin-fzf-doc
%vim_doc_helptags

%files
%defattr(644,root,root,755)
%doc BUILD.md CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/fzf
%dir %{_datadir}/fzf
%{_mandir}/man1/fzf.1*

%files -n bash-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.bash
%{_datadir}/fzf/key-bindings.bash

%files -n zsh-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.zsh
%{_datadir}/fzf/key-bindings.zsh

%files -n vim-plugin-fzf
%defattr(644,root,root,755)
%doc README-VIM.md fzf.vim/README.md
%dir %{_datadir}/fzf/vim
%dir %{_datadir}/fzf/vim/bin
%attr(755,root,root) %{_datadir}/fzf/vim/bin/preview.sh
%attr(755,root,root) %{_datadir}/fzf/vim/bin/tags.pl
%{_datadir}/vim/autoload/fzf
%{_datadir}/vim/plugin/fzf.vim
%{_datadir}/vim/plugin/fzf

%files -n vim-plugin-fzf-doc
%defattr(644,root,root,755)
%{_datadir}/vim/doc/fzf.txt
%changelog
* Sat May 22 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fzf.git;a=log;h=master

* Sat May 22 2021 Jan Palus <atler@pld-linux.org> 95b195a
- up to 0.27.1

* Tue Apr 06 2021 Jan Palus <atler@pld-linux.org> 94f0d80
- disable debugsource packages; rel 2

* Tue Apr 06 2021 Jan Palus <atler@pld-linux.org> bffb72a
- up to 0.27.0

* Sat Mar 13 2021 Jan Palus <atler@pld-linux.org> 555ee18
- switch to manual go build step

* Sat Mar 13 2021 Jan Palus <atler@pld-linux.org> 6659bc3
- up to 0.26.0

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 7932849
- unconditional noarch subpackages

* Sun Jan 03 2021 Jan Palus <atler@pld-linux.org> 84d1c99
- up to 0.25.0

* Mon Dec 21 2020 Jan Palus <atler@pld-linux.org> fe56ff9
- do not rely on uname -m to determine target arch; add more arm variants

* Tue Dec 08 2020 Jan Palus <atler@pld-linux.org> 44d4685
- up to 0.24.4

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> fc3e919
- up to 0.24.2

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> 468eb16
- add feature rich vim plugin extension by same author

* Wed Oct 28 2020 Jan Palus <atler@pld-linux.org> 80124c6
- up to 0.24.1

* Tue Oct 27 2020 Jan Palus <atler@pld-linux.org> 284188b
- up to 0.24.0

* Sun Oct 11 2020 Jan Palus <atler@pld-linux.org> ffe54de
- up to 0.23.1

* Fri Oct 09 2020 Jan Palus <atler@pld-linux.org> 38ff0c7
- typo

* Fri Oct 09 2020 Jan Palus <atler@pld-linux.org> 2f6bb97
- updated supported arch list (32bit x86 dropped by upstream); rel 2

* Thu Oct 08 2020 Jan Palus <atler@pld-linux.org> 635ce84
- up to 0.23.0

* Sun Aug 02 2020 Jan Palus <atler@pld-linux.org> 28e1380
- up to 0.22.0

* Tue Jul 28 2020 Jan Palus <atler@pld-linux.org> 27c72a2
- completion.* are not fzf command completions, they're meant to be sourced; rel 2

* Sat Jul 11 2020 Jan Palus <atler@pld-linux.org> da55bc6
- support same arch list as golang

